summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorFlorian Dold <florian.dold@gmail.com>2020-08-07 13:18:29 +0530
committerFlorian Dold <florian.dold@gmail.com>2020-08-07 13:18:29 +0530
commit5ab2e235c0cb52c5e0b88c1ee68a0ff992188a23 (patch)
tree7e1f0f3e93a9a64f9b99c86817e73d3a73eaf477
parent898de013e70f63221f90289da810f8facc1608f8 (diff)
downloadwallet-core-5ab2e235c0cb52c5e0b88c1ee68a0ff992188a23.tar.gz
wallet-core-5ab2e235c0cb52c5e0b88c1ee68a0ff992188a23.tar.bz2
wallet-core-5ab2e235c0cb52c5e0b88c1ee68a0ff992188a23.zip
add prompt payment scenario
-rwxr-xr-xpackages/taler-integrationtests/scenario26
-rw-r--r--packages/taler-integrationtests/src/scenario-prompt-payment.ts61
2 files changed, 87 insertions, 0 deletions
diff --git a/packages/taler-integrationtests/scenario b/packages/taler-integrationtests/scenario
new file mode 100755
index 000000000..a0050258e
--- /dev/null
+++ b/packages/taler-integrationtests/scenario
@@ -0,0 +1,26 @@
+#!/usr/bin/env bash
+
+# Simple test runner for the wallet integration tests.
+#
+# Usage: $0 TESTGLOB
+#
+# The TESTGLOB can be used to select which test cases to execute
+
+set -eu
+
+if [ "$#" -ne 1 ]; then
+ echo "Usage: $0 SCENARIO"
+ exit 1
+fi
+
+DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
+
+cd $DIR
+
+./node_modules/.bin/tsc
+
+export ESM_OPTIONS='{"sourceMap": true}'
+
+file=lib/scenario-$1.js
+
+exec node -r source-map-support/register -r esm $file
diff --git a/packages/taler-integrationtests/src/scenario-prompt-payment.ts b/packages/taler-integrationtests/src/scenario-prompt-payment.ts
new file mode 100644
index 000000000..615ed5778
--- /dev/null
+++ b/packages/taler-integrationtests/src/scenario-prompt-payment.ts
@@ -0,0 +1,61 @@
+/*
+ This file is part of GNU Taler
+ (C) 2020 Taler Systems S.A.
+
+ GNU Taler is free software; you can redistribute it and/or modify it under the
+ terms of the GNU General Public License as published by the Free Software
+ Foundation; either version 3, or (at your option) any later version.
+
+ GNU Taler is distributed in the hope that it will be useful, but WITHOUT ANY
+ WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+ A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License along with
+ GNU Taler; see the file COPYING. If not, see <http://www.gnu.org/licenses/>
+ */
+
+/**
+ * Imports.
+ */
+import { runTest, GlobalTestState } from "./harness";
+import { createSimpleTestkudosEnvironment, withdrawViaBank } from "./helpers";
+
+/**
+ * Run test for basic, bank-integrated withdrawal.
+ */
+runTest(async (t: GlobalTestState) => {
+ // Set up test environment
+
+ const {
+ wallet,
+ bank,
+ exchange,
+ merchant,
+ } = await createSimpleTestkudosEnvironment(t);
+
+ // Withdraw digital cash into the wallet.
+
+ await withdrawViaBank(t, { wallet, bank, exchange, amount: "TESTKUDOS:20" });
+
+ // Set up order.
+
+ const orderResp = await merchant.createOrder("default", {
+ order: {
+ summary: "Buy me!",
+ amount: "TESTKUDOS:5",
+ fulfillment_url: "taler://fulfillment-success/thx",
+ },
+ });
+
+ let orderStatus = await merchant.queryPrivateOrderStatus(
+ "default",
+ orderResp.order_id,
+ );
+
+ t.assertTrue(orderStatus.order_status === "unpaid")
+
+ console.log(orderStatus);
+
+ // Wait "forever"
+ await new Promise(() => {});
+});